!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_subcube2subcube_template
  use cubetemplate_messaging
  use cubetemplate_one2one_template
  !
  public :: subcube2subcube_comm_t,subcube2subcube_user_t,subcube2subcube_prog_t
  private
  !
  type, extends(one2one_comm_t) :: subcube2subcube_comm_t
  end type subcube2subcube_comm_t
  !
  type, extends(one2one_user_t) :: subcube2subcube_user_t
  end type subcube2subcube_user_t
  !
  type, extends(one2one_prog_t) :: subcube2subcube_prog_t
   contains
     procedure, private :: loop   => cubetemplate_subcube2subcube_prog_loop
     procedure, private :: act    => cubetemplate_subcube2subcube_prog_act
  end type subcube2subcube_prog_t
  !
contains
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_subcube2subcube_prog_loop(prog,itertask,error)
    use cubeadm_taskloop
    use cubeadm_entryloop
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(subcube2subcube_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),      intent(in)    :: itertask
    logical,                       intent(inout) :: error
    !
    integer(kind=entr_k) :: isubcube
    type(subcube_iterator_t) :: itersub
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>PROG>LOOP'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    do isubcube=itertask%first,itertask%last
      call cubeadm_entryloop_iterate(isubcube,error)
      if (error) return
       call itersub%iterate(itertask,isubcube,error)
       if (error) return
       call prog%act(itersub,error)
       if (error) return
    enddo ! isubcube
  end subroutine cubetemplate_subcube2subcube_prog_loop
  !
  subroutine cubetemplate_subcube2subcube_prog_act(prog,itersub,error)
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(subcube2subcube_prog_t), intent(inout) :: prog
    type(subcube_iterator_t),      intent(in)    :: itersub
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>PROG>ACT'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
  end subroutine cubetemplate_subcube2subcube_prog_act
end module cubetemplate_subcube2subcube_template
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
